# Queries

{% hint style="warning" %}
**This is the manual for older MicroStream versions (Version < 5.0).**

**The new documentation (Version >= 5.0) is located at:**

[https://docs.microstream.one/](https://docs.microstream.one/manual)
{% endhint %}

The MicroStream engine takes care of persisting your object graph. When you do queries, they are not run on the data stored by MicroStream, queries run on your data in the local system memory. There is no need to use special query languages like SQL. All operations can be done with plain Java.  MicroStream does not restrict you in the way you query your object graph. You are totally free to choose the best method fitting to your application.&#x20;

One possibility may be Streams if you use the standard Java collections.

```java
public List<Article> getUnAvailableArticles()
{
    return shop.getArticles().stream()
        .filter(a -> !(a.available())).collect(Collectors.toList());
}
```

{% hint style="info" %}
Of course you must care about [lazy loading](/2.1/data-store/loading-data/lazy-loading.md) if you use that feature.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://manual.docs.microstream.one/2.1/data-store/queries.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
